//
//  SafariWebExtensionHandler.swift
//  CashbackExtension
//
//  Created by Shems Boukhatem on 15/12/2021.
//

import SafariServices
import os.log

class SafariWebExtensionHandler: KindredSWEHandler {

    override init() {
        super.init()
        
        let locale = Locale.current

        let currency = locale.currencyCode ?? "USD"
        let country = locale.regionCode ?? "US"

        KindredSettings.shared.saveSetting(obj: currency, key: DataKey.KKUserCurrencyKey)
        KindredSettings.shared.saveSetting(obj: country, key: DataKey.KKUserCountryKey)

        self.setRandomUserId()
        self.setShowEarningsConfirmationMessage(enabled: true)

        KindredSettings.shared.saveSetting(obj: "kindredsafariextensionsampleapp", key: DataKey.KKAppSchemeKey)
    }

    func setRandomUserId() {
        if KindredSettings.shared.getSetting(key: DataKey.KKUserIdKey).isEmpty {
            let userId = UUID().uuidString
            KindredSettings.shared.saveSetting(obj: userId, key: DataKey.KKUserIdKey)
        }
    }
    
    func setShowEarningsConfirmationMessage(enabled: Bool) {
        KindredSettings.shared.saveSetting(obj: enabled, key: DataKey.KKShowEarningsConfirmationMessageKey)
    }
    
    func setShowCashbackLabel(enabled: Bool) {
        KindredSettings.shared.saveSetting(obj: enabled, key: DataKey.KKShowCashbackLabelKey)
    }
}
